mscorlib 2.0.0.0 4.0.0.0 System.Object System.Collections.Generic.ICollection<T> System.Collections.Generic.IEnumerable<T> System.Collections.Generic.IList<T> System.Collections.Generic.IReadOnlyCollection<T> System.Collections.Generic.IReadOnlyList<T> System.Collections.IList System.Diagnostics.DebuggerDisplay("Count={Count}") System.Diagnostics.DebuggerTypeProxy(typeof(System.Collections.Generic.CollectionDebuggerView`1)) To be added.

Implements the interface. The size of a List is dynamically increased as required. A List is not guaranteed to be sorted. It is the programmer's responsibility to sort the List prior to performing operations (such as ) that require a List to be sorted. Indexing operations are required to perform in constant access time; that is, O(1).

Some methods, such as , , , and , use an equality comparer for the list elements. The default equality comparer for type T is determined as follows: If type T implements then the default equality comparer is ; otherwise the default equality comparer is .

Some methods, such as and , use a comparer for the list elements. Some overloads of these methods take an explicit comparer as argument, while others use a default comparer. The default comparer for type T is determined as follows: If type T implements then the default comparer is ; otherwise, if type T implements then the default comparer is . If type T implements neither nor then there is no default comparer; in this case a comparer or comparison delegate must be given explicitly.

The capacity of a is the number of elements the can hold. As elements are added to a , the capacity is automatically increased as required.. The capacity can be decreased by calling or by setting the property explicitly.

Indexes in this collection are zero-based.

accepts as a valid value for reference types and allows duplicate elements.

This type contains a member that is a nested type, called . Although is a member of this type, is not described here; instead, it is described in its own entry, .

- Constructor
  2.0.0.0
  4.0.0.0

  Initializes a new list that is empty and has the default initial capacity.

  If the size of the collection can be estimated, you can specify the initial capacity in a constructor overload that accepts a capacity parameter to eliminate the need to perform a number of resizing operations while adding elements to the list.

- Constructor
  2.0.0.0
  4.0.0.0
  The collection from which to copy the elements.

  Initializes a new list with elements copied from the specified collection, ensuring that the list has sufficient capacity to accommodate the number of elements copied.

  If the size of the collection can be estimated, you can specify the initial capacity in a constructor overload that accepts a capacity parameter to eliminate the need to perform a number of resizing operations while adding elements to the list.

  The elements are copied onto the list in the same order in which they are read by the System.Collections.Generic.IEnumerator<T> from collection.

  is .
- Constructor
  2.0.0.0
  4.0.0.0
  The maximum number of elements that the List can contain without reallocating memory.

  Initializes a new list that is empty and has the specified initial capacity.

  To be added.
  is less than zero.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` The item to add to the end of the list. ( can be if T is a reference type.)

  Adds an item to the end of the list.

  accepts as a valid value for reference types and allows duplicate elements.

  If already equals , the capacity of the list is increased.

  If is less than , this method is an O(1) operation. If the capacity needs to be increased to accommodate the new element, this method becomes an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` The collection whose elements are added to the end of the list.

  Adds the elements of the specified collection to the end of the list.

  accepts as a valid value for reference types and allows duplicate elements.

  The order of the elements in the collection is preserved in the .

  If the new (the current plus the size of the collection) will be greater than , the capacity of the list is increased.

  If the list can accommodate the new elements without increasing , this method is an O(n) operation, where n is the number of elements to be added. If the capacity needs to be increased to accommodate the new elements, this method becomes an O(n + m) operation, where n is the number of elements to be added and m is .

  is .
- Method
  2.0.0.0
  4.0.0.0
  System.Collections.ObjectModel.ReadOnlyCollection<T>

  Returns a read-only wrapper to the current List.

  A read-only wrapper for the current List.

  To prevent any modifications to a list, expose it only through this wrapper.

  A collection that is read-only is simply a collection with a wrapper that prevents modifying the collection; therefore, if changes are made to the underlying collection, the read-only collection reflects those changes.

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` The element for which to search. ( can be if T is a reference type.)

  Searches the entire sorted list for an element using the default comparer, and returns the zero-based index of the element.

  The zero-based index of in the sorted list, if is found; otherwise, a negative number, which is the bitwise complement of the index of the next element that is larger than or, if there is no larger element, the bitwise complement of .

  This method uses the default comparer for type T to determine the order of list elements. If there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  The list must already be sorted according to the comparer implementation; otherwise, the result is incorrect.

  Comparing with any reference type is allowed and does not generate an exception when using . When sorting, is considered to be less than any other object.

  If the list contains more than one element with the same value, the method returns only one of the occurrences, and it might return any one of the occurrences, not necessarily the first one.

  If the list does not contain the specified value, the method returns a negative integer. You can apply the bitwise complement operation (~) to this negative integer to get the index of the first element that is larger than the search value. When inserting the value into the list, this index should be used as the insertion point to maintain the sort order.

  This method is an O(log n) operation, where n is the number of elements in the list.

  The default comparer cannot find a or implementation for type T.

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` The element for which to search. ( can be if T is a reference type.)

  The implementation to use when comparing elements.

  -or-

  to use the default comparer.

  Searches the entire sorted list for an element using the specified comparer and returns the zero-based index of the element.

  The zero-based index of in the sorted list, if is found; otherwise, a negative number, which is the bitwise complement of the index of the next element that is larger than or, if there is no larger element, the bitwise complement of .

  If the given comparer is non-, it is used to determine the order of list elements. If the given comparer is , the default comparer for type T is used; if there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  The comparer customizes how the elements are compared. For example, if T is , you can use a instance as the comparer to perform case-insensitive string searches.

  The list must already be sorted according to the comparer implementation; otherwise, the result is incorrect.

  Comparing with any reference type is allowed and does not generate an exception when using . When sorting, is considered to be less than any other object.

  If the contains more than one element with the same value, the method returns only one of the occurrences, and it might return any one of the occurrences, not necessarily the first one.

  If the list does not contain the specified value, the method returns a negative integer. You can apply the bitwise complement operation (~) to this negative integer to get the index of the first element that is larger than the search value. When inserting the value into the list, this index should be used as the insertion point to maintain the sort order.

  This method is an O(log n) operation, where n is the number of elements in the list.

  is , and the default comparer cannot find a or implementation for type T.

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` `` `` The zero-based starting index of the range to search. The length of the range to search. The element for which to search. ( can be if T is a reference type.)

  The implementation to use when comparing elements.

  -or-

  to use the default comparer.

  Searches a range of elements in the sorted list for an element using the specified comparer and returns the zero-based index of the element.

  The zero-based index of in the sorted list, if is found; otherwise, a negative number, which is the bitwise complement of the index of the next element that is larger than or, if there is no larger element, the bitwise complement of + .

  If the given comparer is non-, it is used to determine the order of list elements. If the given comparer is , the default comparer for type T is used; if there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  The comparer customizes how the elements are compared. For example, if T is , you can use a instance as the comparer to perform case-insensitive string searches.

  The list must already be sorted according to the comparer implementation; otherwise, the result is incorrect.

  Comparing with any reference type is allowed and does not generate an exception when using . When sorting, is considered to be less than any other object.

  If the contains more than one element with the same value, the method returns only one of the occurrences, and it might return any one of the occurrences, not necessarily the first one.

  If the list does not contain the specified value, the method returns a negative integer. You can apply the bitwise complement operation (~) to this negative integer to get the index of the first element that is larger than the search value. When inserting the value into the list, this index should be used as the insertion point to maintain the sort order.

  This method is an O(log n) operation, where n is the number of elements in the range.

  + is greater than .

  is less than zero.

  -or-

  is less than zero.

  is , and the default comparer cannot find a or implementation for type T.

- Property
  2.0.0.0
  4.0.0.0
  System.Int32

  Gets or sets the number of elements the current instance can contain.

  A containing the number of elements the current instance can contain.

  This property is read/write.

  is the number of elements that the list is capable of storing without needing to be extended. is the number of elements that are actually in the list.

  is always greater than or equal to . When exceeds while adding elements, the capacity is increased.

  The capacity can be decreased by calling or by setting the property explicitly.

  Attempt to set the capacity to a value less than .
- Method
  2.0.0.0
  4.0.0.0
  System.Void

  Removes all elements from the list.

  gets set to zero, and references to other objects from elements of the collection are also released. The capacity remains unchanged.

  To reset the capacity, call or set the property directly.

- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` The object to locate in the current collection. ( can be if T is a reference type.)

  Determines whether the list contains a specific value.

  , if is found in the list; otherwise, .

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Collections.Generic.List<TOutput> `` To be added. To be added. To be added. To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` A one-dimensional, zero-based array that is the destination of the elements copied from the list.

  Copies the entire list to an array.

  The elements are copied onto the array (using ) in the same order in which the enumerator iterates through the list.

  is multidimensional.

  -or-

  does not have zero-based indexing.

  -or-

  The number of elements in the list is greater than the number of elements that the destination can contain.

  -or-

  Type T is not assignable to the element type of the destination array.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` A one-dimensional, zero-based array that is the destination of the elements copied from the list. The zero-based index in at which copying begins.

  Copies the elements of the list to an array, starting at a particular index.

  The elements are copied onto the array (using ) in the same order in which the enumerator iterates through the list.

  is multidimensional.

  -or-

  does not have zero-based indexing.

  -or-

  The sum of and number of elements in the list is greater than the length of the destination array.

  -or-

  Type T is not assignable to the element type of the destination array.

  is .

  is less than zero.

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` `` `` The zero-based index in the source list at which copying begins. A one-dimensional, zero-based array that is the destination of the elements copied from the list. The zero-based index in at which copying begins.

  The number of elements to copy.

  Copies a range of elements of the list to an array, starting at a particular index in the target array.

  The elements are copied onto the array (using ) in the same order in which the enumerator iterates through the list.

  is multidimensional.

  -or-

  is equal to or greater than the of the source list.

  -or-

  is equal to or greater than the length of .

  -or-

  The number of elements from to the end of the source list is greater than the available space from to the end of the destination .

  -or-

  Type T is not assignable to the element type of the destination array.

  is .

  is less than zero.

  -or-

  does not have zero-based indexing.

  -or-

  is less than zero.

  -or-

  is less than zero.

- Property
  2.0.0.0
  4.0.0.0
  System.Int32

  Gets the number of elements contained in the current instance.

  The number of elements in the current instance.

  This property is read-only.

- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` The predicate delegate that specifies the elements to search for.

  Determines whether the List contains elements that match the conditions defined by the specified predicate.

  if the List contains one or more elements that match the conditions defined by the specified predicate; otherwise, .

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate, and processing is stopped when a match is found.

  is .

- Method
  2.0.0.0
  4.0.0.0
  T `` The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the first occurrence within the entire List.

  The first element that matches the conditions defined by the specified predicate, if found; otherwise, the default value for type T.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate, moving forward in the List, starting with the first element and ending with the last element. Processing is stopped when a match is found.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Collections.Generic.List<T> `` The predicate delegate that specifies the elements to search for.

  Retrieves all the elements that match the conditions defined by the specified predicate.

  A List containing all the elements that match the conditions defined by the specified predicate, if found; otherwise, an empty List.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the Predicate delegate, and the elements that match the conditions are saved in the returned List.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the first occurrence within the List.

  The zero-based index of the first occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched forward starting at the first element and ending at the last element.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` To be added. The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the first occurrence within the range of elements in the List that extends from the specified index to the last element.

  The zero-based index of the first occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched forward starting at and ending at the last element.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

  is less than 0 or greater than or equal to .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` `` To be added. The number of elements to search. The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the first occurrence within the range of elements in the List that starts at the specified index and contains the specified number of elements.

  The zero-based index of the first occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched forward starting at and ending after elements.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

  is less than 0.

  -or-

  is less than 0.

  -or-

  + is greater than .

- Method
  2.0.0.0
  4.0.0.0
  T `` The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the last occurrence within the entire List.

  The last element that matches the conditions defined by the specified predicate, if found; otherwise, the default value for type T.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate, moving backward in the List, starting with the last element and ending with the first element. Processing is stopped when a match is found.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the last occurrence within the List.

  The zero-based index of the last occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched backward starting at the last element and ending at the first element.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` To be added. The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the last occurrence within the range of elements in the List that extends from the specified index to the first element.

  The zero-based index of the last occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched backward starting at and ending at the first element.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

  is less than 0 or greater than or equal to .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` `` To be added. The number of elements to search. The predicate delegate that specifies the element to search for.

  Searches for an element that matches the conditions defined by the specified predicate, and returns the zero-based index of the last occurrence within the range of elements in the List that starts at the specified index and contains the specified number of elements going backwards.

  The zero-based index of the last occurrence of an element that matches the conditions defined by , if found; otherwise, -1.

  The List is searched backward starting at and ending after elements.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate.

  is .

  is less than zero, or greater than or equal to .

  -or-

  is less than 0.

  -or-

  is greater than + 1.

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` The action delegate to perform on each element of the List.

  Performs the specified action on each element of the List.

  The action is a delegate that performs an action on the object passed to it. The elements of the current List are individually passed to the action delegate, sequentially, in index order, and on the same thread as that used to call . Execution stops if the action throws an exception.

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Collections.Generic.List<T>+Enumerator

  Returns an enumerator, in index order, that can be used to iterate over the list.

  An enumerator for the list.

  For a detailed description regarding the use of an enumerator, see .

- Method
  2.0.0.0
  4.0.0.0
  System.Collections.Generic.List<T> `` `` The zero-based index at which the range starts. The number of elements in the range.

  Creates a shallow copy of a range of elements in the current List.

  A shallow copy of the given range of elements in the list.

  A shallow copy of a collection, or a subset of that collection, copies only the elements of the collection, whether they are reference types or value types, but it does not copy the objects that the references refer to. The references in the new collection point to the same objects as do the references in the original collection. (In contrast, a deep copy of a collection copies the elements and everything directly or indirectly referenced by those elements.)

  + is greater than .

  is less than 0.

  -or-

  is less than 0.

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` To be added.

  Searches for the specified object and returns the zero-based index of the first occurrence within the entire list.

  The zero-based index of the first occurrence of within the List, if found; otherwise, -1.

  The list is searched forward starting at the first element and ending at the last element.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method performs a linear search; therefore, the average number of comparisons is proportional to . That is, this method is an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` To be added. The zero-based starting index of the search.

  Searches for the specified object and returns the zero-based index of the first occurrence within the range of elements in the list that extends from the specified index to the last element.

  The zero-based index of the first occurrence of within the range of elements in the list, if found; otherwise, -1.

  The list is searched forward starting at and ending at the last element.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is the number of elements from to the end of the list.

  is less than zero or greater than .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` `` To be added. The zero-based starting index of the search. The number of elements to search.

  Searches for the specified object and returns the zero-based index of the first occurrence within the range of elements in the list that starts at the specified index and contains the specified number of elements.

  The zero-based index of the first occurrence of within the specified range of elements in the list, if found; otherwise, -1.

  The list is searched forward starting at and ending at + - 1, and searching at most terms.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is .

  is less than 0.

  -or-

  is less than 0.

  -or-

  + is greater than .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` The zero-based index at which is to be inserted. The item to insert. ( can be if T is a reference type.)

  Inserts an item to the List at the specified position.

  accepts as a valid value for reference types and allows duplicate elements.

  If already equals , the capacity of the List is increased.

  If is equal to , is added to the end of list.

  is less than 0.

  -or-

  is greater than .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` The zero-based index at which the new elements should be inserted. The collection whose elements should be inserted into the list. ( itself cannot be , but the collection can contain elements that are , if type T is a reference type.)

  Inserts the elements of a collection in the List at the specified position.

  accepts as a valid value for reference types and allows duplicate elements.

  If the new value of will be greater than , the capacity of the List is increased.

  If is equal to , the collection is added to the end of list.

  The order of the elements in the collection is preserved in the list.

  is .

  is less than zero,

  -or-

  is greater than .

- Property
  2.0.0.0
  4.0.0.0
  T `` The zero-based index of the element in the current instance to get or set.

  Gets or sets the element at the specified index of the current instance.

  The element at the specified index of the current instance.

  To be added.

  < 0.

  -or-

  >= of the current instance.

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` To be added.

  Searches for the specified object and returns the zero-based index of the last occurrence within the entire list.

  The zero-based index of the last occurrence of within the entire list, if found; otherwise, -1.

  The list is searched backward starting at the last element and ending at the first element.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` To be added. The zero-based starting index of the search.

  Searches for the specified object and returns the zero-based index of the last occurrence within the range of elements in the list that extends from the specified index to the last element.

  The zero-based index of the last occurrence of within the range of elements in the list, if found; otherwise, -1.

  The list is searched backward starting at and ending at the first element.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is the number of elements from the beginning of the list to .

  is less than zero or greater than or equal to .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` `` `` To be added. The zero-based starting index of the search. The number of elements to search.

  Searches for the specified object and returns the zero-based index of the last occurrence within the range of elements in the list that starts at the specified index and contains the specified number of elements.

  The zero-based index of the last occurrence of within the range of elements in the list that contains number of elements and ends at , if found; otherwise, -1.

  The list is searched backward starting at and ending after elements.

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is .

  is less than zero, or greater than or equal to .

  -or-

  is less than 0.

  -or-

  is greater than + 1.

- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` The object to be removed from the list.

  Removes the first occurrence of the specified object from the list.

  if is successfully removed; otherwise, .

  This method uses the default equality comparer for type T to determine equality of list elements. The default equality comparer for element type T is defined in the Description section of this (class ) specification.

  This method is an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` The predicate delegate that specifies the elements to remove.

  Removes the all the elements that match the conditions defined by the specified predicate.

  The number of elements removed from the List.

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate, and the elements that match the conditions are removed from the List.

  This method is an O(n) operation, where n is .

  is .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` The zero-based index of the item to remove.

  Removes the item at the specified index of the list.

  The item is removed and all the elements following it in the List have their indexes reduced by 1.

  This method is an O(n) operation, where n is .

  is less than 0.

  -or-

  is equal to or greater than .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` The zero-based starting index of the range of elements to remove. The number of elements to remove.

  Removes a range of elements from the list.

  The items are removed and all the elements following them in the List have their indexes reduced by .

  + is greater than .

  is less than zero.

  -or-

  is less than zero.

- Method
  2.0.0.0
  4.0.0.0
  System.Void

  Reverses the order of the elements in the list.

  This method uses to reverse the order of the elements.

  This method is an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` The zero-based starting index of the range of elements to reverse. The number of elements to reverse.

  Reverses the order of the elements in the specified element range of the list.

  This method reverses the order of the elements in the specified element range

  This method is an O(n) operation, where n is .

  + is greater than .

  is less than zero.

  -or-

  is less than zero.

- Method
  2.0.0.0
  4.0.0.0
  System.Void

  Sorts the elements in the list using the default comparer.

  This method uses the default comparer for type T to determine the order of list elements. If there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  At worst, this operation is O(n2), where n is the number of elements to sort. On average it's O(n log n).

  The default comparer cannot find a or implementation for type T.

- Method
  2.0.0.0
  4.0.0.0
  System.Void ``

  The implementation to use when comparing elements.

  -or-

  to use the default comparer.

  Sorts the elements in the list using the specified comparer.

  If the given comparer is non-, it is used to determine the order of list elements. If the given comparer is , the default comparer for type T is used; if there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  At worst, this operation is O(n2), where n is the number of elements to sort. On average it's O(n log n).

  is , and the default comparer cannot find a or implementation for type T.

- Method
  2.0.0.0
  4.0.0.0
  System.Void ``

  The comparison to use when comparing elements.

  Sorts the elements in the list using the specified comparison.

  At worst, this operation is O(n2), where n is the number of elements to sort. On average it's O(n log n).

  is .
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` `` The zero-based starting index of the range of elements to sort. The number of elements to sort.

  The implementation to use when comparing elements.

  -or-

  to use the default comparer.

  Sorts the elements in the list using the specified comparer.

  If the given comparer is non-, it is used to determine the order of list elements. If the given comparer is , the default comparer for type T is used; if there is no default comparer, then the method throws . The default comparer for a given element type T is defined in the Description section of this (class ) specification.

  At worst, this operation is O(n2), where n is the number of elements to sort. On average it's O(n log n).

  + is greater than .

  is less than zero.

  -or-

  is less than zero.

  is , and the default comparer cannot find a or implementation for type T.

- Property
  2.0.0.0
  4.0.0.0
  System.Boolean

  This read-only property is implemented to support the interface.

  For more information, see .

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Collections.Generic.IEnumerator<T>

  This method is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` To be added. To be added.

  This method is implemented to support the interface.

  To be added.
- Property
  2.0.0.0
  4.0.0.0
  System.Boolean

  This read-only property is implemented to support the interface.

  To be added. To be added.
- Property
  2.0.0.0
  4.0.0.0
  System.Object

  This read-only property is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Collections.IEnumerator

  This method is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` To be added.

  This method is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` To be added.

  This method is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Int32 `` To be added.

  This method is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` `` To be added. To be added.

  This method is implemented to support the interface.

  To be added.
- Property
  2.0.0.0
  4.0.0.0
  System.Boolean

  This read-only property is implemented to support the interface.

  To be added. To be added.
- Property
  2.0.0.0
  4.0.0.0
  System.Boolean

  This read-only property is implemented to support the interface.

  To be added. To be added.
- Property
  2.0.0.0
  4.0.0.0
  System.Object `` To be added.

  This read-only property is implemented to support the interface.

  To be added. To be added.
- Method
  2.0.0.0
  4.0.0.0
  System.Void `` To be added.

  This method is implemented to support the interface.

  To be added.
- Method
  2.0.0.0
  4.0.0.0
  T[]

  Copies the elements in the list to a new array.

  The new array containing a copy of the list's elements.

  This an O(n) operation, where n is .

- Method
  2.0.0.0
  4.0.0.0
  System.Void

  Suggests that the capacity be reduced to the actual number of elements in the list.

  This method can be used to suggest a collection's memory overhead be minimized, e.g., if no new elements are expected to be added to the collection.

  To reset a list to its initial state, call the method before calling .

- Method
  2.0.0.0
  4.0.0.0
  System.Boolean `` The predicate delegate that specifies the check against the elements.

  Determines whether every element in the List matches the conditions defined by the specified predicate.

  , if every element in the List matches the conditions defined by the specified predicate; otherwise, .

  The predicate is a delegate that returns if the object passed to it matches the conditions defined in the delegate. The elements of the current List are individually passed to the predicate delegate. The elements are processed sequentially and on the same thread.

  is .